#ifndef HELPERDLOGGER_H_
#define HELPERDLOGGER_H_

#include <include_closed/app/log/Logger.h> // to get the definition of FHGFS_LOGGER_TYPE

#if FHGFS_LOGGER_TYPE == FHGFS_HELPERDLOGGER

/*
 * The rest of this is declared in the closed tree.
 */

struct Logger;
typedef struct Logger Logger;


extern void Logger_logFormatted(Logger* this, int level, const char* context,
   const char* msgFormat, ...);
extern void Logger_logErrFormatted(Logger* this, const char* context,
   const char* msgFormat, ...);

extern int Logger_getLogLevel(Logger* this);

// inliners
static inline void Logger_log(Logger* this, int level, const char* context, const char* msg);
static inline void Logger_logErr(Logger* this, const char* context, const char* msg);



void Logger_log(Logger* this, int level, const char* context, const char* msg)
{
   Logger_logFormatted(this, level, context, "%s", msg);
}


void Logger_logErr(Logger* this, const char* context, const char* msg)
{
   Logger_logErrFormatted(this, context, "%s", msg);
}


#endif // FHGFS_LOGGER_TYPE == FHGFS_HELPERDLOGGER

#endif /* HELPERDLOGGER_H_ */
