#ifndef STORAGEDEFINITIONS_H_
#define STORAGEDEFINITIONS_H_

/*
 * Remember to keep these definitions in sync with StorageDefinitions.h of fhgfs_common!
 */


#include <include_closed/common/Common.h>


// rw flags
#define OPENFILE_ACCESS_READ           1
#define OPENFILE_ACCESS_WRITE          2
#define OPENFILE_ACCESS_READWRITE      4
// extra flags
#define OPENFILE_ACCESS_APPEND         8
#define OPENFILE_ACCESS_TRUNC         16
// masks
#define OPENFILE_ACCESS_MASK_RW       \
   (OPENFILE_ACCESS_READ | OPENFILE_ACCESS_WRITE | OPENFILE_ACCESS_READWRITE)
#define OPENFILE_ACCESS_MASK_EXTRA    (~OPENFILE_ACCESS_RW_MASK)


#define SETATTR_CHANGE_MODE               1
#define SETATTR_CHANGE_USERID             2
#define SETATTR_CHANGE_GROUPID            4
#define SETATTR_CHANGE_MODIFICATIONTIME   8
#define SETATTR_CHANGE_LASTACCESSTIME    16


struct SettableFileAttribs;
typedef struct SettableFileAttribs SettableFileAttribs;


enum ListDirIncStage
   {ListDirIncStage_START=0, ListDirIncStage_DIRS=1, ListDirIncStage_FILES=2,
   ListDirIncStage_END=3};
typedef enum ListDirIncStage ListDirIncStage;


/**
 * Note: Typically used in combination with a value of SETATTR_CHANGE_...-Flags to determine which
 * of the fields are actually used
 */
struct SettableFileAttribs
{
   int mode;
   unsigned userID;
   unsigned groupID;
   int64_t modificationTimeSecs;
   int64_t lastAccessTimeSecs;
};


#endif /*STORAGEDEFINITIONS_H_*/
