#ifndef FHGFSOPSHELPER_H_
#define FHGFSOPSHELPER_H_

#include <include_open/common/storage/Open_StorageErrors.h>
#include <include_open/common/Open_Common.h>
#include <include_closed/filesystem/FsDirInfo.h>
#include <include_closed/filesystem/FsFileInfo.h>
#include <include_closed/common/toolkit/MetadataTk.h>
#include <include_closed/net/filesystem/FhgfsOpsRemoting.h>


extern int FhgfsOpsHelper_refreshDirInfoIncremental(App* app, const OwnerMinInfo* entryInfo,
   loff_t currentOffset, FsDirInfo* dirInfo, fhgfs_bool forceUpdate);

extern int FhgfsOpsHelper_symlink(App* app, const OwnerMinInfo* parentInfo, const char* entryName,
   const char* to, unsigned userID, unsigned groupID, int mode, OwnerMinInfo* outEntryInfo);
extern int FhgfsOpsHelper_readlink(App* app, const OwnerMinInfo* entryInfo, char __user* buf,
   int size);

extern ssize_t FhgfsOpsHelper_readStateless(App* app, const OwnerMinInfo* entryInfo,
   char __user *buf, size_t size, loff_t offset);
extern ssize_t FhgfsOpsHelper_writeStateless(App* app, const OwnerMinInfo* entryInfo,
   const char __user *buf, size_t size, loff_t offset);

extern FhgfsOpsErr FhgfsOpsHelper_flushCache(App* app, FsFileInfo* fileInfo, RemotingIOInfo* ioInfo,
   fhgfs_bool discardCacheOnError);
extern ssize_t FhgfsOpsHelper_writeCached(App* app, const char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo, RemotingIOInfo* ioInfo);
extern ssize_t FhgfsOpsHelper_readCached(App* app, char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo, RemotingIOInfo* ioInfo);


extern ssize_t __FhgfsOpsHelper_writeCacheFlushed(App* app, const char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo, RemotingIOInfo* ioInfo);
extern ssize_t __FhgfsOpsHelper_readCacheFlushed(App* app, char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo, RemotingIOInfo* ioInfo);


#endif /*FHGFSOPSHELPER_H_*/
