#ifndef FSFILEINFO_H_
#define FSFILEINFO_H_

#include <include_closed/common/Common.h>
#include <include_open/filesystem/Open_FhgfsInode.h>
#include "FsObjectInfo.h"


enum FileBufferType; // forward declaration
struct StripePattern; // forward declaration
struct IntCpyVec; // forward declaration
struct FhgfsInode; // forward declaration
struct RemotingIOInfo; // forward declaration

struct FsFileInfo;
typedef struct FsFileInfo FsFileInfo;


extern void FsFileInfo_init(FsFileInfo* this, App* app, unsigned accessFlags,
   FileHandleType handleType);
extern FsFileInfo* FsFileInfo_construct(App* app, unsigned accessFlags, FileHandleType handleType);
extern void FsFileInfo_uninit(FsObjectInfo* this);
extern void FsFileInfo_destruct(FsObjectInfo* this);

// inliners
extern void FsFileInfo_incCacheHits(FsFileInfo* this, size_t cacheHits);
extern void FsFileInfo_decCacheHits(FsFileInfo* this, size_t cacheHits);

// getters & setters
extern unsigned FsFileInfo_getAccessFlags(FsFileInfo* this);
extern FileHandleType FsFileInfo_getHandleType(FsFileInfo* this);
extern void FsFileInfo_setAppending(FsFileInfo* this, fhgfs_bool appending);
extern fhgfs_bool FsFileInfo_getAppending(FsFileInfo* this);
extern void FsFileInfo_setMaxUsedNodeIndex(FsFileInfo* this, int maxUsedNodeIndex);
extern int FsFileInfo_getMaxUsedNodeIndex(FsFileInfo* this);
extern size_t FsFileInfo_getCacheHits(FsFileInfo* this);
extern void FsFileInfo_setAllowCaching(FsFileInfo* this, fhgfs_bool allowCaching);
extern fhgfs_bool FsFileInfo_getAllowCaching(FsFileInfo* this);
extern void FsFileInfo_setCacheType(FsFileInfo* this, enum FileBufferType cacheType);
extern enum FileBufferType FsFileInfo_getCacheType(FsFileInfo* this);
extern size_t FsFileInfo_getCacheID(FsFileInfo* this);
extern void FsFileInfo_getIOInfo(FsFileInfo* this, struct FhgfsInode* fhgfsInode,
   struct RemotingIOInfo* outIOInfo);


#endif /*FSFILEINFO_H_*/
