#ifndef STORAGEERRORS_H_
#define STORAGEERRORS_H_

/*
 * Remember to keep these definitions in sync with StorageErrors.h of fhgfs_common!
 */


#include <include_open/common/Open_Common.h>


// Note: keep this above __FHGFSOPS_ERRLIST declaration
struct FhgfsOpsErrListEntry
{
   const char* errString; // human-readable error string
   int         sysErr;    // positive linux system error code
};


extern struct FhgfsOpsErrListEntry const __FHGFSOPS_ERRLIST[];


// Note: Remember to keep this in sync with FHGFSOPS_ERRLIST
enum FhgfsOpsErr
{
   FhgfsOpsErr_SUCCESS                 =     0,
   FhgfsOpsErr_INTERNAL                =     1,
   FhgfsOpsErr_INTERRUPTED             =     2,
   FhgfsOpsErr_COMMUNICATION           =     3,
   FhgfsOpsErr_COMMTIMEDOUT            =     4,
   FhgfsOpsErr_UNKNOWNNODE             =     5,
   FhgfsOpsErr_NOTOWNER                =     6,
   FhgfsOpsErr_EXISTS                  =     7,
   FhgfsOpsErr_PATHNOTEXISTS           =     8,
   FhgfsOpsErr_INUSE                   =     9,
   FhgfsOpsErr_DYNAMICATTRIBSOUTDATED  =    10,
   FhgfsOpsErr_PARENTTOSUBDIR          =    11,
   FhgfsOpsErr_NOTADIR                 =    12,
   FhgfsOpsErr_NOTEMPTY                =    13,
   FhgfsOpsErr_NOSPACE                 =    14,
};
typedef enum FhgfsOpsErr FhgfsOpsErr;



extern const char* FhgfsOpsErr_toErrString(FhgfsOpsErr fhgfsOpsErr);
extern int FhgfsOpsErr_toSysErr(FhgfsOpsErr fhgfsOpsErr);




#endif /*STORAGEERRORS_H_*/
