#ifndef OPEN_CONDITION_H_
#define OPEN_CONDITION_H_

#include <include_open/common/Open_Common.h>
#include <include_open/common/toolkit/Open_Time.h>
#include "Open_Mutex.h"


struct Condition;
typedef struct Condition Condition;

enum cond_wait_res;
typedef enum cond_wait_res cond_wait_res_t;

extern void Condition_init(Condition* this);
extern Condition* Condition_construct(void);
extern void Condition_uninit(Condition* this);
extern void Condition_destruct(Condition* this);

extern cond_wait_res_t Condition_wait(Condition* this, Mutex* mutex);
extern cond_wait_res_t Condition_timedwait(Condition* this,
   Mutex* mutex, int timeoutMS);
extern void Condition_broadcast(Condition* this);
extern void Condition_signal(Condition* this);


enum cond_wait_res
{
   COND_WAIT_TIMEOUT =  0, // make sure that timeout is always 0 
   COND_WAIT_SUCCESS =  1,
   COND_WAIT_SIGNAL  = -1
};



#endif /*OPEN_CONDITION_H_*/
