#ifndef OPEN_SERIALIZATION_H_
#define OPEN_SERIALIZATION_H_

#include <include_open/common/Open_Common.h>


extern uint16_t Serialization_cpu_to_be16(uint16_t value);
extern uint16_t Serialization_be16_to_cpu(uint16_t value);
extern uint32_t Serialization_cpu_to_be32(uint32_t value);
extern uint32_t Serialization_be32_to_cpu(uint32_t value);
extern uint64_t Serialization_cpu_to_be64(uint64_t value);
extern uint64_t Serialization_be64_to_cpu(uint64_t value);

extern uint32_t Serialization_cpu_to_le16(uint16_t value);
extern uint32_t Serialization_le16_to_cpu(uint16_t value);
extern uint32_t Serialization_cpu_to_le32(uint32_t value);
extern uint32_t Serialization_le32_to_cpu(uint32_t value);
extern uint64_t Serialization_cpu_to_le64(uint64_t value);
extern uint64_t Serialization_le64_to_cpu(uint64_t value);

// inliners
static inline unsigned Serialization_htonlTrans(unsigned value);
static inline unsigned Serialization_ntohlTrans(unsigned value);
static inline unsigned short Serialization_htonsTrans(unsigned short value);
static inline unsigned short Serialization_ntohsTrans(unsigned short value);
static inline uint64_t Serialization_htonllTrans(uint64_t value);
static inline uint64_t Serialization_ntohllTrans(uint64_t value);



// byte-order transformation

unsigned Serialization_htonlTrans(unsigned value)
{
   return Serialization_cpu_to_be32(value);
   //return htonl(value);
}

unsigned Serialization_ntohlTrans(unsigned value)
{
   return Serialization_be32_to_cpu(value);
   //return ntohl(value);
}

unsigned short Serialization_htonsTrans(unsigned short value)
{
   return Serialization_cpu_to_be16(value);
   //return htons(value);
}

unsigned short Serialization_ntohsTrans(unsigned short value)
{
   return Serialization_be16_to_cpu(value);
   //return ntohs(value);
}

uint64_t Serialization_htonllTrans(uint64_t value)
{
   return Serialization_cpu_to_be64(value);
   //return (((int64_t)(Serialization_ntohlTrans((int)((value << 32) >> 32))) << 32) |
   //            (unsigned int)Serialization_ntohlTrans(((int)(value >> 32))) );
}

uint64_t Serialization_ntohllTrans(uint64_t value)
{
   return Serialization_be64_to_cpu(value);
   //return Serialization_htonllTrans(value);
}


#endif /* OPEN_SERIALIZATION_H_ */
