#ifndef OPEN_FHGFSINODE_H_
#define OPEN_FHGFSINODE_H_

#include <include_open/common/Open_Common.h>
#include <include_closed/common/toolkit/MetadataTk.h>
#include <include_closed/net/filesystem/RemotingIOInfo.h>

/*
 * The rest of this is declared in the open tree.
 */

struct FhgfsInode; // forward declaration


enum FileHandleType;
typedef enum FileHandleType FileHandleType;


// getters & setters
extern void FhgfsInode_getRefIOInfo(struct FhgfsInode* this, FileHandleType handleType,
   unsigned accessFlags, int* pMaxUsedNodeIndex, RemotingIOInfo* outIOInfo);

// inliners
static inline void FhgfsInode_freeOwnerMinInfoVals(OwnerMinInfo* entryInfo);



enum FileHandleType // (note: used as array index for FhgfsInode::fileHandles)
   {FileHandleType_READ=0, FileHandleType_RW=1, FileHandleType_WRITE=2};


/**
 * Note: This is just a generic kfree of the values that exists to make life of
 * _getOwnerMinInfoCopy()-callers easier.
 *
 * @param entryInfo values will be kfree'd, not the entryInfo struct itself
 */
void FhgfsInode_freeOwnerMinInfoVals(OwnerMinInfo* entryInfo)
{
   os_kfree(entryInfo->ownerNodeID);
   os_kfree(entryInfo->entryID);
}



#endif /* OPEN_FHGFSINODE_H_ */
