#ifndef OPEN_OSDEPS_H_
#define OPEN_OSDEPS_H_

#include <linux/types.h>
#include <linux/compiler.h>

#include <include_open/common/Open_FhgfsTypes.h>


extern fhgfs_bool os_checkCompileTimeAssumptions(void);

extern void* os_kmalloc(size_t size);
extern void* os_kzalloc(size_t size);
extern void os_kfree(const void* addr);
extern void* os_vmalloc(unsigned long size);
extern void os_vfree(void* addr);
extern unsigned long __os_get_free_page(void);
extern void os_free_page(unsigned long addr);

extern void* os_memcpy(void* to, const void* from, size_t n);
extern void* os_memset(void* s, int c, size_t n);
extern int os_memcmp(const void* cs, const void* ct, size_t count);

extern int __os_copy_from_user(void *dst, const void __user *src, unsigned size);
extern int __os_copy_to_user(void __user *dst, const void *src, unsigned size);

extern int os_printk(const char* fmt, ...);
extern int os_sprintf(char* buf, const char* fmt, ...);
extern int os_snprintf(char* buf, size_t size, const char* fmt, ...);
extern int os_vsnprintf(char* buf, size_t size, const char* fmt, va_list args);
extern int os_scnprintf(char* buf, size_t size, const char* fmt, ...);

extern size_t os_strlen(const char* s);
extern int os_strcmp(const char *s1, const char *s2);
extern int os_strnicmp(const char *s1, const char *s2, size_t n);
extern char* os_strcpy(char* dest, const char* src);
extern char* os_strchr(const char* s,int c);
extern char* os_strrchr(const char* s, int c);

extern const char* os_getCurrentCommNameStr(void);
extern pid_t os_getCurrentPID(void);


extern fhgfs_bool __os_checkCompileTimeErrDefs(void);


#endif /* OPEN_OSDEPS_H_ */
