#ifndef OPEN_COMMON_INTERNAL_H_
#define OPEN_COMMON_INTERNAL_H_

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/kthread.h>
#include <linux/sched.h> // for TASK_COMM_LEN
#include <linux/string.h>
#include <linux/time.h>
#include <linux/types.h>
#include <linux/version.h>
#include <linux/vmalloc.h>
#include <linux/errno.h>
#include <asm/uaccess.h>


#include <include_open/common/Open_Common.h>


// not defined for old kernel versions
#ifndef TASK_COMM_LEN
#define TASK_COMM_LEN   16
#endif


/* wrappers for get_fs()/set_fs() */
#define ACQUIRE_PROCESS_CONTEXT(fs_varname) \
   do { fs_varname = get_fs(); set_fs(KERNEL_DS); } while(0)
#define RELEASE_PROCESS_CONTEXT(fs_varname) \
   set_fs(fs_varname)



#endif /* OPEN_COMMON_INTERNAL_H_ */
