#include "Mutex.h"

struct Mutex
{
   struct semaphore sema;
};


void Mutex_init(Mutex* this)
{
   init_MUTEX(&this->sema);
}

Mutex* Mutex_construct(void)
{
   Mutex* this = (Mutex*)os_kmalloc(sizeof(*this) );

   Mutex_init(this);

   return this;
}

void Mutex_uninit(Mutex* this)
{
}

void Mutex_destruct(Mutex* this)
{
   Mutex_uninit(this);

   kfree(this);
}

void Mutex_lock(Mutex* this)
{
   down(&this->sema);
}

void Mutex_unlock(Mutex* this)
{
   up(&this->sema);
}

