#ifndef FHGFSOPSDIR_H_
#define FHGFSOPSDIR_H_

#include <include_closed/app/App.h>
#include <include_open/common/threading/Open_Mutex.h>
#include <include_open/common/Open_Common.h>
#include <include_open/common/toolkit/Open_Time.h>
#include <include_closed/net/filesystem/FhgfsOpsRemoting.h>
#include <include_closed/filesystem/FsDirInfo.h>
#include <include_closed/filesystem/FsFileInfo.h>
#include <include_closed/toolkit/NoAllocBufferStore.h>
#include <include_closed/common/toolkit/MetadataTk.h>
#include <open/common/Common.h>
#include "FhgfsOps_versions.h"
#include "FhgfsOpsInode.h"

#include <linux/dcache.h>


extern struct dentry_operations fhgfs_dentry_ops;


extern int FhgfsOps_revalidate(struct dentry* dentry, struct nameidata* nameidata);
extern int FhgfsOps_deleteDentry(struct dentry* dentry);

extern char* __FhgfsOps_pathResolveToStoreBuf(NoAllocBufferStore* bufStore,
   const struct dentry* dentry, char** outStoreBuf);
//extern char* __FhgfsOps_fullpathResolveToPage(
//   struct dentry* dentry, struct vfsmount* mnt, char** outPageBuf);


#endif /* FHGFSOPSDIR_H_ */
