#ifndef FHGFSOPSSUPER_H_
#define FHGFSOPSSUPER_H_

#include <include_closed/app/App.h>
#include <open/common/Common.h>
#include "FhgfsOps_versions.h"

#include <linux/fs.h>
#include <linux/vfs.h>


#define FHGFS_MAGIC                    0x19830326 /* some random number to identify fhgfs */


extern int __FhgfsOps_initApp(struct super_block* sb, char* rawMountOptions);
extern void __FhgfsOps_uninitApp(App* app);

extern int FhgfsOps_registerFilesystem(void);
extern int FhgfsOps_unregisterFilesystem(void);

extern int __FhgfsOps_fillSuper(struct super_block* sb, void* rawMountOptions, int silent);
extern void FhgfsOps_putSuper(struct super_block* sb);
extern void FhgfsOps_killSB(struct super_block* sb);

extern void __FhgfsOps_forceDentryRelease(struct super_block *sb);

// getters & setters
static inline App* FhgfsOps_getApp(struct super_block* sb);
static inline void FhgfsOps_setApp(struct super_block* sb, App* app);



App* FhgfsOps_getApp(struct super_block* sb)
{
   return (App*)sb->s_fs_info;
}

void FhgfsOps_setApp(struct super_block* sb, App* app)
{
   sb->s_fs_info = app;
}



#endif /* FHGFSOPSSUPER_H_ */
