#ifndef PROCFS_H_
#define PROCFS_H_

#include <open/common/Common.h>
#include <include_closed/app/App.h>


extern void ProcFs_createGeneralDir(void);
extern void ProcFs_removeGeneralDir(void);
extern void ProcFs_createEntries(App* app);
extern void ProcFs_removeEntries(App* app);

extern int ProcFs_read_nothing(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_read_config(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_read_mgmtNodes(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_read_metaNodes(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_read_storageNodes(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_read_clientInfo(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_write_removeMgmtNode(struct file* file, const char __user *buf,
   unsigned long count, void* data);
extern int ProcFs_write_removeMetaNode(struct file* file, const char __user *buf,
   unsigned long count, void* data);
extern int ProcFs_write_removeStorageNode(struct file* file, const char __user *buf,
   unsigned long count, void* data);
extern int ProcFs_read_connRetriesEnabled(char* buf, char** start, off_t offset, int size, int* eof,
   void* data);
extern int ProcFs_write_connRetriesEnabled(struct file* file, const char __user *buf,
   unsigned long count, void* data);

#endif /* PROCFS_H_ */
